\\ Copyright 2014, 2017 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.


\\ Centroid of boundary segments.


read("../tools/memoize.gp")

check_equal(got,want) =
{
  if(got!=want, print("wrong\n","got\n",got,"\nwant\n",want);
                quit(1),
                print("ok"));
}
vector_mean(v) = vecsum(v)/#v;
R(k) = if(k==0, 1, 3*2^(k-1));
V(k) = if(k==0, 2, 3*2^(k-1));

\\ (1 + sqrt(3)*I)/2
\\ D=-3
sqrt3i = quadgen(4*-3);
w6 = 1/2 + 1/2*sqrt3i;
check_equal(w6^3, -1)
check_equal(w6^6, 1)

w3 = w6^2;

b = w6 + 1;

RT(k) = 2^k;

\\-----------------------------------------------------------------------------
\\
\\               *__       __*       *   *     *---*     *---*
\\    *----*      \/       \/         \ /         /       \
\\      \/         *       *           *         *         *
\\   RT(1,0)    RT(1,1)  RT(1,2)    RT(2,0)    RT(2,1)   RT(2,2)
\\
\\
\\                                 *
\\                                /
\\                               /                ___
\\        *-----*         *     *-----*         *     *
\\         \               \   / \   /           \   /
\\          \               \ /   \ /             \ /
\\     *-----*               *     +               *

\\ RT(1,0) -> RT(1,0) + RT(2,2)
\\ RT(1,1) -> RT(1,1) + RT(2,0)
\\ RT(1,2) -> RT(1,2) + RT(2,1)
\\
\\ RT(2,0) -> RT(2,0) + RT(1,2)
\\ RT(2,1) -> RT(2,1) + RT(1,0)
\\ RT(2,2) -> RT(2,2) + RT(1,1)
\\
\\ oppose RT(1,0) = RT(2,0)

\\    1        0  1  0    RT(1,0)
\\       1     0     1    RT(1,1)
\\          1  1  0  0    RT(1,2)
\\    0  1  0  1          RT(2,0)
\\    0     1     1  1    RT(2,1)
\\    1  0  0        1    RT(2,2)

m = {[ 1,0,0,0,1,0;
       0,1,0,0,0,1;
       0,0,1,1,0,0;
       0,1,0,1,0,0;
       0,0,1,0,1,0;
       1,0,0,0,0,1 ]};
v=[1;0;0; 0;0;0];
RT(k,s,d) = d%=3; my(p=m^k*v); p[3*(s-1)+d+1,1];
for(k=0,10,printf("k=%2d  ",k); for(s=1,2, for(d=0,2, printf(" %3d",RT(k,s,d)))); print(""))

\\                        *----*
\\                         \
\\                          \
\\                     *-----*
\\                      \   / \
\\                       \ /   \
\\        *-----*         *-----*
\\         \               \
\\          \               \
\\     *-----*          *----*
\\
\\  RT(1,0)=1         RT(1,0)=1
\\                    RT(1,1)=1
\\                    .
\\                    .
\\                    .
\\  RT(2,2)=1         RT(2,2)=2

\\ k= 0     1   0   0   0   0   0
\\ k= 1     1   0   0   0   0   1
\\ k= 2     1   1   0   0   0   2
\\ k= 3     1   3   0   1   0   3
\\ k= 4     1   6   1   4   0   4
\\ k= 5     1  10   5  10   1   5
\\ k= 6     2  15  15  20   6   6
\\ k= 7     8  21  35  35  21   8
\\ k= 8    29  29  70  56  56  16
\\ k= 9    85  45 126  85 126  45
\\ k=10   211  90 211 130 252 130


\\ k= 0    1   0   0    0   0   0
\\ k= 1    1   0   0    0   0   1
\\ k= 2    1   1   0    0   0   2
\\ k= 3    1   3   0    1   0   3
\\ k= 4    1   6   1    4   0   4
\\ k= 5    1  10   5   10   1   5
\\ k= 6    2  15  15   20   6   6
\\ k= 7    8  21  35   35  21   8
\\ k= 8   29  29  70   56  56  16
\\ k= 9   85  45 126   85 126  45
\\ k=10  211  90 211  130 252 130
\\        c   a   e    f   d   b
\\
\\ a(n) + d(n) = A024495(n)    d=1 
\\ b(n) + e(n) = A131708(n)    d=2
\\ c(n) + f(n) = A024493(n)    d=0 1s+2s
\\
\\ A024495  = C(n,2) + C(n,5) + ...
\\ A131708  = C(n,1) + C(n,4) + ... 
\\ A024493  = C(n,0) + C(n,3) + ... 

RTM(k,s,d) = RT(k,s,d+k);
RTN(k,s,d) = RT(k,s,d-k);

for(s=1,2, for(d=0,2, print("d"); for(k=0,20, printf("%d,",RT(k,s,d)));print("")))


sumchoose(k,d) = sum(i=0,k,binomial(k,3*i+d));
for(k=0,10,printf("k=%2d  ",k); for(d=0,2, printf(" %3d", sumchoose(k,d))); print(""))
for(k=0,10,printf("k=%2d  ",k); for(d=0,2, printf(" %3d", RTN(k,1,d)+RTN(k,2,d))); print(""))


\\ A227430
\\ x^2*(1-x)^3/((1-2*x)*(1-x+x^2)*(1-3*x+3x^2))
\\ 2,
\\ 1/2 + sqrt(3)/2*I     abs=1
\\ 1/2 - sqrt(3)/2*I
\\ 1/2 + sqrt(3)/6*I     abs=sqrt(3)/3 = 1/sqrt(3)
\\ 1/2 - sqrt(3)/6*I

check_equal( (1 - (3/2 + sqrt3i/2)* x) * (1 - (3/2 - sqrt3i/2)* x), 1-3*x+3*x^2)
check_equal(b, 3/2 + sqrt3i/2)

{
check_equal( (1 - 2*x)
            * (1 - (1/2 + sqrt3i/2)* x)
            * (1 - (1/2 - sqrt3i/2)* x)
            * (1 - (3/2 + sqrt3i/2)* x)
            * (1 - (3/2 - sqrt3i/2)* x),

            ((1-2*x)*(1-x+x^2)*(1-3*x+3*x^2)))
}

{
check_equal( (1 - 2*x)
            * (1 - w6* x)
            * (1 - conj(w6)* x)
            * (1 - b*x)
            * (1 - conj(b)*x),

            ((1-2*x)*(1-x+x^2)*(1-3*x+3*x^2)))
}

{
matsolve([1,  1,        1, 1,       1;
          2, w6, conj(w6), b, conj(b);
          2^2,w6^2,conj(w6)^2,b^2,conj(b)^2;
          2^3,w6^3,conj(w6)^3,b^3,conj(b)^3;
          2^4,w6^4,conj(w6)^4,b^4,conj(b)^4],
         [1;1;1;1;1])
}
RT10(k) = {
    if(k==0,return(1));
      1/3/2*2^k
    + (1/12 + 1/12*sqrt3i)/w6*w6^k
    + (1/12 - 1/12*sqrt3i)/conj(w6)*conj(w6)^k
    + ( 1/4 + 1/12*sqrt3i)/b*b^k
    + ( 1/4 - 1/12*sqrt3i)/conj(b)*conj(b)^k;
}
for(k=0,16, printf(" %3d", RT(k,1,0))); print("");
for(k=0,16, printf(" %3d", RT10(k))); print("");

RT10(k) = {
    if(k==0,return(1));
    1/6*(  2^k
         + w6^k
         + conj(w6)^k
         + b^k
         + conj(b)^k );
}
for(k=0,16, printf(" %3d", RT10(k))); print("");

\\ = A214438
\\ s(j) 2,1,1,0,-1,-1, -2,-1,-1,0,1,1
\\      2,1,1,0,-1,-1, -2,-1,-1,0,1,1, 2,1,1,0,-1,-1,-2,-1,-1,0,1,1,
for(k=0,23, print1(  (b^k + conj(b)^k)/3^ceil(k/2),","  ));print("")

\\ = A087204
\\      2,1,-1,-2,-1,1, 2,1,-1,-2,-1,1, 2,1,-1,-2,-1,1, 2,1,-1,-2,-1,1,
for(k=0,23, print1(  (w6^k + conj(w6)^k),","  ));print("")
