\\ Copyright 2014, 2017 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.

\\ v(k) = m*v(k-1) + S

\\ S = {[1/2*9^(k-1) * sin^2(alpha+150)
\\       1/2*9^(k-1) * sin^2(alpha    )
\\       1/2*9^(k-1) * sin^2(alpha+ 30)
\\       1/2*9^(k-1) * sin^2(alpha+ 60)
\\       1/2*9^(k-1) * sin^2(alpha+ 90)
\\       1/2*9^(k-1) * sin^2(alpha+120)]}
\\ S = [a,b,c,d,e,f]
\\ fkdslfjsd

nearly_equal(x,y) = abs(x-y) < 1e-6
near_rat(x) = if(nearly_equal(x*4,round(x*4)), round(x*4)/4, x)
alpha=0
s0=near_rat( sin(alpha+  0/180*Pi)^2 )
s1=near_rat( sin(alpha+ 30/180*Pi)^2 )
s2=near_rat( sin(alpha+ 60/180*Pi)^2 )
s3=near_rat( sin(alpha+ 90/180*Pi)^2 )
s4=near_rat( sin(alpha+120/180*Pi)^2 )
s5=near_rat( sin(alpha+150/180*Pi)^2 )
s0=11;s1=13;s2=17;s3=19;s4=23;s5=29
refP0(k) = if(k==0,0, 1/3 * refP5(k-1) + 2/3 * refP3(k-1) + 1/2*9^(k-1) * s5 )
refP1(k) = if(k==0,0, 1/3 * refP0(k-1) + 2/3 * refP4(k-1) + 1/2*9^(k-1) * s0 )
refP2(k) = if(k==0,0, 1/3 * refP1(k-1) + 2/3 * refP5(k-1) + 1/2*9^(k-1) * s1 )
refP3(k) = if(k==0,0, 1/3 * refP2(k-1) + 2/3 * refP0(k-1) + 1/2*9^(k-1) * s2 )
refP4(k) = if(k==0,0, 1/3 * refP3(k-1) + 2/3 * refP1(k-1) + 1/2*9^(k-1) * s3 )
refP5(k) = if(k==0,0, 1/3 * refP4(k-1) + 2/3 * refP2(k-1) + 1/2*9^(k-1) * s4 )

want = {[vector(12,k,refP0(k-1))
         \\ ,
         \\ vector(12,k,refP1(k-1)),
         \\ vector(12,k,refP2(k-1)),
         \\ vector(12,k,refP3(k-1)),
         \\ vector(12,k,refP4(k-1)),
         \\ vector(12,k,refP5(k-1))
        ]}

check() =
{
  got=[vector(12,k,P0(k-1))
\\ ,
\\        vector(12,k,P1(k-1)),
\\        vector(12,k,P2(k-1)),
\\        vector(12,k,P3(k-1)),
\\        vector(12,k,P4(k-1)),
\\        vector(12,k,P5(k-1))
];
  if(got!=want, print("wrong\n","got\n",got,"\nwant\n",want);
                quit(1),
                print("ok\n"));
}

P0(k) = if(k<1,refP0(k), 1/3 * P5(k-1) + 2/3 * P3(k-1) + 1/2*9^(k-1) * s5 )
P1(k) = if(k<1,refP1(k), 1/3 * P0(k-1) + 2/3 * P4(k-1) + 1/2*9^(k-1) * s0 )
P2(k) = if(k<1,refP2(k), 1/3 * P1(k-1) + 2/3 * P5(k-1) + 1/2*9^(k-1) * s1 )
P3(k) = if(k<1,refP3(k), 1/3 * P2(k-1) + 2/3 * P0(k-1) + 1/2*9^(k-1) * s2 )
P4(k) = if(k<1,refP4(k), 1/3 * P3(k-1) + 2/3 * P1(k-1) + 1/2*9^(k-1) * s3 )
P5(k) = if(k<1,refP5(k), 1/3 * P4(k-1) + 2/3 * P2(k-1) + 1/2*9^(k-1) * s4 )
check()

\\ P0(k) = if(k<=1,want[1][k+1], 1/3 * (1/3*P4(k-2) + 2/3*P2(k-2) + 1/2*9^(k-2)*s4) + 2/3 * P3(k-1) + 1/2*9^(k-1) * s5 )
\\ P1(k) = if(k<=1,want[2][k+1], 1/3 * P0(k-1) + 2/3 * P4(k-1) + 1/2*9^(k-1) * s0 )
\\ P2(k) = if(k<=1,want[3][k+1], 1/3 * P1(k-1) + 2/3 * (1/3*P4(k-2) + 2/3*P2(k-2) + 1/2*9^(k-2)*s4) + 1/2*9^(k-1) * s1 )
\\ P3(k) = if(k<=1,want[4][k+1], 1/3 * P2(k-1) + 2/3 * P0(k-1) + 1/2*9^(k-1) * s2 )
\\ P4(k) = if(k<=1,want[5][k+1], 1/3 * P3(k-1) + 2/3 * P1(k-1) + 1/2*9^(k-1) * s3 )
\\ P5(k) = refP5(k)  
\\ check()
\\ 
\\ P0(k) = if(k<=2,want[1][k+1], 2/27*P1(k-3) + 2/9*P2(k-2) + 2/3*P3(k-1) + 1/27*P3(k-3)   + 1/18*s3*9^(k-3) + 1/6*9^(k-2)*s4 + 1/2*9^(k-1)*s5 )
\\ P1(k) = if(k<=2,want[2][k+1], 1/3*P0(k-1) + 4/9*P1(k-2) + 2/9*P3(k-2)               + 1/3*9^(k-2)*s3 + 1/2*9^(k-1)*s0 )
\\ P2(k) = if(k<=2,want[3][k+1], 1/3*P1(k-1) + 4/27*P1(k-3) + 4/9*P2(k-2) + 2/27*P3(k-3)   + 1/9*9^(k-3)*s3 + 1/3*9^(k-2)*s4 + 1/2*9^(k-1)*s1 )
\\ P3(k) = if(k<=2,want[4][k+1], 1/3 * P2(k-1) + 2/3 * P0(k-1) + 1/2*9^(k-1)*s2 )
\\ P4(k) = refP4(k)  
\\ P5(k) = refP5(k)  
\\ check()
\\ 
\\ P0(k) = if(k<=3,want[1][k+1], 2/27*P1(k-3) + 2/9*P2(k-2) + 2/3*(1/3*P2(k-2) + 2/3*P0(k-2) + 1/2*9^(k-2)*s2) + 1/27*(1/3*P2(k-4) + 2/3*P0(k-4) + 1/2*9^(k-4)*s2)   + 1/18*s3*9^(k-3) + 1/6*9^(k-2)*s4 + 1/2*9^(k-1)*s5 )
\\ P1(k) = if(k<=3,want[2][k+1], 1/3*P0(k-1) + 4/9*P1(k-2) + 2/9*(1/3*P2(k-3) + 2/3*P0(k-3) + 1/2*9^(k-3)*s2)               + 1/3*9^(k-2)*s3 + 1/2*9^(k-1)*s0 )
\\ P2(k) = if(k<=3,want[3][k+1], 1/3*P1(k-1) + 4/27*P1(k-3) + 4/9*P2(k-2) + 2/27*(1/3*P2(k-4) + 2/3*P0(k-4) + 1/2*9^(k-4)*s2)   + 1/9*9^(k-3)*s3 + 1/3*9^(k-2)*s4 + 1/2*9^(k-1)*s1 )
\\ P3(k) = refP3(k)
\\ P4(k) = refP4(k)  
\\ P5(k) = refP5(k)  
\\ check()
\\ 
\\ P0(k) = if(k<=3,want[1][k+1], 4/9*P0(k-2) + 1/27*2/3*P0(k-4) + 2/27*P1(k-3) + 4/9*P2(k-2) + 1/81*P2(k-4)   + 1/18*s3*9^(k-3) + 1/6*9^(k-2)*s4 + 1/2*9^(k-1)*s5 + 2/3*1/2*9^(k-2)*s2 + 1/27*1/2*9^(k-4)*s2)
\\ P1(k) = if(k<=3,want[2][k+1], 1/3*P0(k-1) + 4/27*P0(k-3) + 4/9*P1(k-2) + 2/27*P2(k-3)    + 1/9*9^(k-3)*s2 + 1/3*9^(k-2)*s3 + 1/2*9^(k-1)*s0 )
\\ P2(k) = if(k<=3,want[3][k+1], 4/81*P0(k-4) + 1/3*P1(k-1) + 4/27*P1(k-3) + 4/9*P2(k-2) + 2/81*P2(k-4)    + 1/27*9^(k-4)*s2 + 1/9*9^(k-3)*s3 + 1/3*9^(k-2)*s4 + 1/2*9^(k-1)*s1 )
\\ P3(k) = refP3(k)
\\ P4(k) = refP4(k)  
\\ P5(k) = refP5(k)  
\\ check()
\\ 
\\ \\ P1(k) = 1/3*P0(k-1) + 4/27*P0(k-3) + 4/9*P1(k-2) + 2/27*P2(k-3)    + 1/9*9^(k-3)*s2 + 1/3*9^(k-2)*s3 + 1/2*9^(k-1)*s0
\\ \\ P2(k-3) = 27/2*( P1(k) - 1/3*P0(k-1) - 4/27*P0(k-3) - 4/9*P1(k-2) - 1/9*9^(k-3)*s2 - 1/3*9^(k-2)*s3 - 1/2*9^(k-1)*s0)
\\ \\ P2(k-3) = 27/2*P1(k) - 27/2*1/3*P0(k-1) - 27/2*4/27*P0(k-3) - 27/2*4/9*P1(k-2) - 27/2*1/9*9^(k-3)*s2 - 27/2*1/3*9^(k-2)*s3 - 27/2*1/2*9^(k-1)*s0
\\ \\ P2(k-3) = 27/2*P1(k) - 9/2*P0(k-1) - 2*P0(k-3) - 6*P1(k-2) - 3/2*9^(k-3)*s2 - 9/2*9^(k-2)*s3 - 27/4*9^(k-1)*s0
\\ \\
\\ \\ P2(k-2) = 27/2*P1(k+1) - 9/2*P0(k) - 2*P0(k-2) - 6*P1(k-1) - 3/2*9^(k-2)*s2 - 9/2*9^(k-1)*s3 - 27/4*9^(k)*s0
\\ 
\\ P0(k) = if(k<=4,want[1][k+1], 4/27*P0(k-2) + 2/243*P0(k-4) + 2/81*P1(k-3) + 2*P1(k+1) - 8/27*P0(k-2) - 8/9*P1(k-1) - 2/9*9^(k-2)*s2 - 2/3*9^(k-1)*s3 - 9^(k)*s0 + 1/243*P2(k-4)   + 1/54*s3*9^(k-3) + 1/18*9^(k-2)*s4 + 1/6*9^(k-1)*s5 + 1/9*9^(k-2)*s2 + 1/162*9^(k-4)*s2)
\\ P1(k) = refP1(k)
\\ P2(k) = if(k<=4,want[3][k+1], 4/81*P0(k-4) + 1/3*P1(k-1) + 4/27*P1(k-3) + 4/9*P2(k-2) + 2/81*P2(k-4)    + 1/27*9^(k-4)*s2 + 1/9*9^(k-3)*s3 + 1/3*9^(k-2)*s4 + 1/2*9^(k-1)*s1 )
\\ P3(k) = refP3(k)
\\ P4(k) = refP4(k)  
\\ P5(k) = refP5(k)  
\\ check()
\\ 
\\ P0(k) = if(k<=4,want[1][k+1], 4/27*P0(k-2) + 2/243*P0(k-4) + 2/81*P1(k-3) + 2*P1(k+1) - 8/27*P0(k-2) - 8/9*P1(k-1) - 2/9*9^(k-2)*s2 - 2/3*9^(k-1)*s3 - 9^(k)*s0 + 1/243*P2(k-4)   + 1/54*s3*9^(k-3) + 1/18*9^(k-2)*s4 + 1/6*9^(k-1)*s5 + 1/9*9^(k-2)*s2 + 1/162*9^(k-4)*s2)
\\ P1(k) = refP1(k)
\\ P2(k) = if(k<=4,want[3][k+1], 4/81*P0(k-4) + 1/3*P1(k-1) + 4/27*P1(k-3) + 6*P1(k+1) - 2*P0(k) - 8/9*P0(k-2) - 8/3*P1(k-1) - 2/3*9^(k-2)*s2 - 2*9^(k-1)*s3 - 3*9^(k)*s0 + 2/81*P2(k-4)    + 1/27*9^(k-4)*s2 + 1/9*9^(k-3)*s3 + 1/3*9^(k-2)*s4 + 1/2*9^(k-1)*s1 )
\\ P3(k) = refP3(k)
\\ P4(k) = refP4(k)  
\\ P5(k) = refP5(k)  
\\ check()
\\ 
\\ \\ P2(k-4) = - 9/2*P0(k-2) - 2*P0(k-4) + 27/2*P1(k-1) - 6*P1(k-3) - 3/2*9^(k-4)*s2 - 9/2*9^(k-3)*s3 - 27/4*9^(k-2)*s0
\\ 
\\ P0(k) = {if(k<=4,want[1][k+1],
\\             4/27*P0(k-2) - 17/54*P0(k-2)
\\             + 2*P1(k+1) - 5/6*P1(k-1) 
\\             - 2917/36  *9^(k-2) * s0
\\             - 9^(k-3) * s2
\\             - 54 *9^(k-3)*s3
\\             + 1/18*9^(k-2)*s4
\\             + 1/6*9^(k-1)*s5
\\            )}
\\ P1(k) = refP1(k)
\\ P2(k) = {if(k<=4,want[3][k+1],
\\             - 2*P0(k) - P0(k-2)
\\             + 6*P1(k+1) - 2*P1(k-1) 
\\             -1459/6      *9^(k-2)*s0
\\             + 1/2    *9^(k-1)*s1
\\             - 54  *9^(k-4)*s2
\\             - 162  *9^(k-3)*s3
\\             + 1/3 *9^(k-2)*s4
\\            )}
\\ P3(k) = refP3(k)
\\ P4(k) = refP4(k)  
\\ P5(k) = refP5(k)  
\\ check()
\\ 
\\ \\ P2(k) = - 9/2*P0(k+2) - 2*P0(k) + 27/2*P1(k+3) - 6*P1(k+1) - 3/2*9^(k)*s2 - 9/2*9^(k+1)*s3 - 27/4*9^(k+2)*s0

\\------------------------------------------------------------------------------

refQ(k) = 9^k
Q(k)=refQ(k);

m = {[  0,   0,   0, 2/3,   0, 1/3, 1/2*s5; 
      1/3,   0,   0,   0, 2/3,   0, 1/2*s0; 
        0, 1/3,   0,   0,   0, 2/3, 1/2*s1; 
      2/3,   0, 1/3,   0,   0,   0, 1/2*s2; 
        0, 2/3,   0, 1/3,   0,   0, 1/2*s3; 
        0,   0, 2/3,   0, 1/3,   0, 1/2*s4;
        0,   0,   0,   0,   0,   0, 9
     ]}

v0={[1,0,0,0,0,0,0;
     0,0,0,0,0,0,0;
     0,0,0,0,0,0,0;
     0,0,0,0,0,0,0;
     0,0,0,0,0,0,0;
     0,0,0,0,0,0,0;
     0,0,0,0,0,0,0
    ];}
v1={[0,0,0,0,0,0,0;
     1,0,0,0,0,0,0;
     0,0,0,0,0,0,0;
     0,0,0,0,0,0,0;
     0,0,0,0,0,0,0;
     0,0,0,0,0,0,0;
     0,0,0,0,0,0,0
    ];}
v2={[0,0,0,0,0,0,0;
     0,0,0,0,0,0,0;
     1,0,0,0,0,0,0;
     0,0,0,0,0,0,0;
     0,0,0,0,0,0,0;
     0,0,0,0,0,0,0;
     0,0,0,0,0,0,0
    ];}
v3={[0,0,0,0,0,0,0;
     0,0,0,0,0,0,0;
     0,0,0,0,0,0,0;
     1,0,0,0,0,0,0;
     0,0,0,0,0,0,0;
     0,0,0,0,0,0,0;
     0,0,0,0,0,0,0
    ];}
v4={[0,0,0,0,0,0,0;
     0,0,0,0,0,0,0;
     0,0,0,0,0,0,0;
     0,0,0,0,0,0,0;
     1,0,0,0,0,0,0;
     0,0,0,0,0,0,0;
     0,0,0,0,0,0,0
    ];}
v5={[0,0,0,0,0,0,0;
     0,0,0,0,0,0,0;
     0,0,0,0,0,0,0;
     0,0,0,0,0,0,0;
     0,0,0,0,0,0,0;
     1,0,0,0,0,0,0;
     0,0,0,0,0,0,0
    ];}
v6={[0,0,0,0,0,0,0;
     0,0,0,0,0,0,0;
     0,0,0,0,0,0,0;
     0,0,0,0,0,0,0;
     0,0,0,0,0,0,0;
     0,0,0,0,0,0,0;
     1,0,0,0,0,0,0
    ];}

my(k=1); m^3* [P0(k-1);P1(k-1);P2(k-1);P3(k-1);P4(k-1);P5(k-1);Q(k-1)]

my(k=0); p0s = [refP0(k);refP0(k+1);refP0(k+2);refP0(k+3);refP0(k+4);refP0(k+5);refP0(k+6)]
init = [0;0;0;0;0;0;1]
c = v0*m^0 + v1*m^1 + v2*m^2 + v3*m^3 + v4*m^4 + v5*m^5 + v6*m^6
r = c*m*c^-1
\\ m^3*init
\\ refP0(8)
\\ \\ c^-1*p0s
\\ r*p0s
\\ \\ 1351498285/162
\\ \\ want [[0, 29/2, 140, 22867/18, 34328/3, 5561663/54, 8342572/9, 1351498285/162, 2027247656/27, 328414125209/486, 492621188500/81, 79804632551845/1458]]

P0(k) = (r^k*p0s)[1,1]
P1(k) = refP1(k);
P2(k) = refP2(k);
P3(k) = refP3(k);
P4(k) = refP4(k); 
P5(k) = refP5(k); 
P6(k) = refP6(k); 
check()

\\ P0(k+7) = P0(k)                   k+5 k+6
\\             -1  1/9  4  -4/9  -12 4/3  9

P0(k) = {if(k<7, refP0(k),
            9*P0(k-1) + 4/3*P0(k-2) - 12*P0(k-3) - 4/9*P0(k-4) + 4*P0(k-5) + 1/9*P0(k-6) - P0(k-7))}
P1(k) = refP1(k);
P2(k) = refP2(k);
P3(k) = refP3(k);
P4(k) = refP4(k); 
P5(k) = refP5(k); 
P6(k) = refP6(k); 
check()

poly = -(-x^7 + 9*x^6 + 4/3*x^5 - 12*x^4 - 4/9*x^3 + 4*x^2 + 1/9*x - 1)

polroots(poly)
\\ -1, 1, 9
\\ -0.5000000000000000000000000000 - 0.2886751345948128822545743903*I,
\\ -0.5000000000000000000000000000 + 0.2886751345948128822545743903*I,
\\  0.5000000000000000000000000000 - 0.2886751345948128822545743903*I,
\\  0.5000000000000000000000000000 + 0.2886751345948128822545743903*I]~
\\ +/- 1/2 +/- sqrt(3)/6
\\
\\ 9^k + c + (-1)^k +


\\-----------------------------------------------------------------------------
\\ sin(A+B) = sinA*cosB + cosA*sinB
\\ cos(A+B) = cosA*cosB - sinA*sinB
\\
\\ sin^2(A+B) = sinA^2*cosB^2 + cosA^2*sinB^2 + 2*sinA*cosA * sinB*cosB
\\ cos^2(A+B) = cosA^2*cosB^2 + sinA^2*sinB^2 - 2*sinA*cosA * sinB*cosB
\\
\\ Ix = m*r^2*sinA^2
\\ Iy = m*r^2*cosA^2
\\ Ib = m*r^2*sin^2(A+B)
\\    = m*r^2*(sinA^2*cosB^2 + cosA^2*sinB^2 + 2*sinA*cosA * sinB*cosB)
\\    = m*r^2*sinA^2*cosB^2 + m*r^2*cosA^2*sinB^2 + 2*m*r^2*sinA*cosA*sinB*cosB
\\    = Ix*cosB^2 + Iy*sinB^2 + 2*m*r^2*sinA*cosA*sinB*cosB
\\ sinA = sqrt(Ix/m)/r
\\ cosA = sqrt(Iy/m)/r
\\ Ib = Ix*cosB^2 + Iy*sinB^2 + 2*m*r^2*sqrt(Ix/m)/r*sqrt(Iy/m)/r *sinB*cosB
\\ Ib = Ix*cosB^2 + Iy*sinB^2 + 2*sqrt(Ix*Iy) *sinB*cosB