#!/usr/bin/perl -w

# Copyright 2017, 2018 Kevin Ryde
#
# This file is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 3, or (at your option) any later
# version.
#
# This file is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.
#
# You should have received a copy of the GNU General Public License along
# with this file.  If not, see <http://www.gnu.org/licenses/>.

use 5.004;
use strict;
use FindBin;
use Math::PlanePath::AlternateTerdragon;

BEGIN { unshift @INC, $FindBin::Bin }
use MyLineSegments;
use MyPrintwrap ':all';
use MyTerdragon 'xy_rotate_plus60','xy_rotate_minus60';


$Printwrap = 2;
printwrap("% generated by tools/$FindBin::Script\n");

my $level = 6;
my $path = Math::PlanePath::AlternateTerdragon->new;

my ($n_lo, $n_hi) = $path->level_to_n_range($level);
foreach my $arm (-1, 1, 0) {
  my $segments = MyLineSegments->new;
  foreach my $n ($n_lo .. int($n_hi/2)+14) {
    my ($x1,$y1) = $path->n_to_xy($n);
    my ($x2,$y2) = $path->n_to_xy($n+1);
    if ($arm == -1) {
      ($x1,$y1) = xy_rotate_minus60($x1,$y1);
      ($x2,$y2) = xy_rotate_minus60($x2,$y2);
    } elsif ($arm == 1) {
      ($x1,$y1) = xy_rotate_plus60($x1,$y1);
      ($x2,$y2) = xy_rotate_plus60($x2,$y2);
    }
    $segments->add($x1,$y1, $x2,$y2);
  }
  my $colour = ($arm ? '[my grey] ' : '');
  $Printwrap = 2;
  printwrap("\\draw$colour ");
  $Printwrap += 2;
  $segments->printwrap;
  printwrap(";\n");
}

print "  % end generated\n";
exit 0;
